import java.util.*;
import java.text.*;

class Beispiel1 {
    final static String pfad = "f:\\daten\\uni\\1.semester\\eprog\\abgabe1\\beispiel1";
    final static String filename = "ARTIKEL.TXT";

    // Hauptprogramm
    public static void main(String argv[]) 
	{
	// Initialisierung der Varible a, dabei wird die Liste der Artikel eingelesen
        Artikeln a = new Artikeln ();

	try {
	    // Einlesen der Artikel
	    a.DatenLesen (pfad,filename);
	    }
	catch (Exception e)
	    {
	    System.out.println(e.getMessage());
	    }

	// Ausgabe der vorhanden Artikel
	a.printall();
		
	// Initialisiert die Rechnungsklasse
	Rechnung r = new Rechnung ();

	// Einlesen der Rechnungen aus dem File & deren Ausgabe
	for (int i=1; i<=9; i++)
	    {
	    System.out.print ("\nRechnung " + i + ":\n\n");
	    try {
	    r.load (pfad,"Rechnung" + i + ".txt");
		}
	    catch (Exception e)
		{
		System.out.println (e.getMessage());
		}
	    
	    Berechnung b = new Berechnung (a,r);
	    r.destroy ();
	    }
	}
    }

        
// Hier werden die Artikeldaten abgelegt
class Daten
    {
    int nummer = 0;
    String name = null;
    double preis = 0;
    
    
    // Konstruktor fr neues Element
    Daten(int nr, String na, double p)
	{
	nummer= nr;
	name = na;
	preis = p;
	}
    }


// Verwaltet die Artikel
class Artikeln
    {
    Daten[] a = new Daten[30];
    private int anz;
    
    // Konstruktor
    Artikeln ()
	{
	anz = 0;
	}

    // Konstruktor: Liet die Artikel ein
    void DatenLesen (String path, String filename) throws Exception
	{
	String s = null;

	// ffnet das File "Artikel.txt" und legt die Daten in Daten ab
	ReadFile file = new ReadFile (path, filename);
	while ((s = file.readLine()) != null)
	    {
    	    // Wenn zu viele Artikel: Abbruch
	    if (anz >= 30)
		throw new Exception ("Zu viel Artikel im File - Es wurden nur die ersten 30 bercksichtigt.");
		
	    try 
		{
		// Wandelt einen String ins Artikelformat um
		StringtoArtikel (s);
		}
	    catch (Exception e)
		{
		System.out.println ("Fehler: " + e.getMessage());
		}
	    }
	file.close ();
	}


    // Versucht den bergebenen String im Array "Artikel" abzulegen	
    void StringtoArtikel (String s) throws Exception
	{
	int nummer = 0;
	String name = null;
	double preis = 0;
	
	// Initialisiert Stringteiler und definiert die Trennzeichen
	StringTokenizer T = new StringTokenizer (s, ",");

	try {
	    // berprft, ob die Parameteranzahl korrekt ist
	    if ((T.countTokens () != 3) || (s.charAt (s.length () - 1) == ','))
		throw new Exception ("Falsche Syntax:\t" + s + "\tDatensatz ignoriert.\n\t\t <Artikelnummer>,<Bezeichnung>,<Preis>");

	    // Liet die Artikelnummer, wenn nicht dreistellig Abbruch
	    name = T.nextToken ();
	    if (name.length() !=3)
		throw new Exception ("Ungltige Artikelnummer im angegebenen File.");
	    nummer = Integer.parseInt (name);

	    // Liet Artikelnamen, berprft, ob der Artikelname zulssig ist, und bricht bei Fehler ab
	    name = T.nextToken ();
	    if (name.length() > 20)
		throw new Exception ("Artikelbezeichnung zu lang (max. 20 Zeichen)");
    
	    // Liet den Preis
	    preis = Double.valueOf(T.nextToken()).doubleValue();
	    } 
	catch (Exception e)
	    {
	    throw new Exception (e.getMessage());
	    }
	    
	// Wenn kein Fehler bei der Umwandlung aufgetreten ist, Datensatz speichern
	a[anz++] = new Daten (nummer,name,preis);
	}
	
	
    // Gibt die Liste aller vorhanden Artikel aus
    void printall ()
	{
	System.out.print ("\nListe der vorhandenen Artikel:\n\n");
	for (int i = 0; i < anz; i++)
	    System.out.println (a[i].nummer + ", " + a[i].name + ", " + a[i].preis);
	System.out.print ("\n\n\n");
	}
    
    // Sucht in Artikeldaten nach bergebener Artikelnummer und gibt sie bei Erfolg zurck
    int find (int art)
	{
	for (int i = 0; i < anz; i++)
	    if (art == a[i].nummer)
		return (i);
	return -1;
	}
    }


// Hier werden die Rechenstze abgelegt
class Rechnungen
    {
    int artikel;
    int menge;
    Rechnungen (int a, int m)
	{
	artikel = a;
	menge = m;
	}
    }


// Verwaltet die Rechenstze
class Rechnung
    {
    Rechnungen [] r = new Rechnungen [10];
    private int anz;

    // leerer Konstruktor
    Rechnung ()
	{
	anz = 0;
	}

    // liet die Rechnungen aus angegebenem File ein
    void load (String path, String filename) throws Exception
	{
	String s = null;
	int stck = 0, trennzeichen = 0, artikel = 0, artnr = 0;
		
	// ffnet File
	ReadFile file = new ReadFile (path, filename);
	
	// Liet bis zum Fileende ein, oder bricht bei mehr als 10 Rechnungsstzen ab
	while ((s = file.readLine()) != null)
	    {
	    // Abbruch, wenn mehr als 10 Rechenstzen
            if (anz > 10)
	        throw new Exception ("Zu viele Artikel in dieser Rechnung.\nEs wurden nur die ersten 10 bercksichtigt.");
	    try 
		{	
		// Wandelt Sting in Rechnungsdatensatz um
		StringtoRechnung (s);
		}
	    catch (Exception e)
		{
		System.out.println (e.getMessage ());
		}
    	    }
	}


    // Versucht den bergebenen String im Array "Rechnungen" abzulegen	
    void StringtoRechnung (String s) throws Exception
	{
	int artikel = 0, stck = 0, artnr = 0;
	String help = null;
	
	// Initialisiert Stringteiler und definiert die Trennzeichen
	StringTokenizer T = new StringTokenizer (s, ",");

	try {
	    if ((T.countTokens () != 2) || (s.charAt (s.length () - 1) == ','))
		throw new Exception ("Falsche Syntax:\t" + s + "\tDatensatz ignoriert.\n\t\t <Artikelnummer>,<Menge>");
	    artikel = Integer.parseInt (T.nextToken());
	    stck = Integer.parseInt (T.nextToken());
	    } 
	catch (Exception e)
	    {
	    throw new Exception ("Fehler im Datensatz:\t" + s + "\tDatensatz ignoriert.");
	    }
	    
	// berprft, ob dieser Artikel in der Rechnung schon vorkommt
	//  ja: ergnzt den alten Rechnungssatz
	//  nein: legt neuen Rechnungssatz an
	if ((artnr = find (artikel)) >= 0)
	    r [artnr].menge += stck;
	else
	    r [anz++] = new Rechnungen (artikel, stck);
	}


    // Sucht in Rechnungsstzen nach angegebener Artikelnummer
    int find (int art)
	{
	for (int i = 0; i < anz; i++)
	    if (art == r[i].artikel)
		return (i);
	return -1;
	}
    
    // Liefert die Anzahl der geladenen Rechnungen zurck
    int anz ()
	{
	return anz;
	}
    
    // Setzt die Eintrge auf 0 zurck
    void destroy ()
	{
	anz = 0;
	}
    }


// Fhrt die Berechnungen durch
class Berechnung 
    {
    Berechnung (Artikeln a, Rechnung e)
    	{
	int j=0;
	double gesamtpreis = 0;
	String trennung = "=========================================================";
	NumberFormat N = NumberFormat.getInstance ();
	N.setMaximumFractionDigits (2);	
	N.setMinimumFractionDigits (2);	
	N.setGroupingUsed (false);
	System.out.print ("\n");
	for(int i = 0; i < e.anz(); i++)
	    {
	    if(0 <= (j = a.find (e.r[i].artikel)))
		{
		System.out.println (i + 1 + "\t" + a.a[j].nummer + "\t" + a.a[j].name + "\t" + a.a[j].preis + "\t" + e.r[i].menge + "\t" + N.format(a.a[j].preis * e.r[i].menge));
		gesamtpreis += a.a[j].preis * e.r[i].menge;
		}
	    else
		System.out.println (i + 1 + "\t" + e.r[i].artikel + "\tArtikel nicht gefunden");
	    }
	System.out.print (trennung + "\nGesamtpreis:\t\t\t\t" + N.format(gesamtpreis) + "\n\n");
	}
    }
    