/*  Programm:	Beispiel2.java
    Aufgabe:	Liet Daten aus einem File ein, und konvertiert sie in anderes Format
    Formate:    1999/1/1
		1999-1-1
		1. Jnner 1999 oder 1. Jan. 1999 */
    
import java.util.*;
import java.text.*;

class Beispiel2
    {
    final static String pfad = "f:\\daten\\uni\\1.semester\\eprog\\abgabe1\\beispiel2\\";
    final static String filename = "test.txt";
        
    public static void main (String argv[])
	{
	Datum d = new Datum ();
	String s = null;

	// ffnet File
	ReadFile file = new ReadFile (pfad, filename);
	
	// Solange Zeilen vorhanden: einlesen
	while ((null != (s = file.readLine())) && (s.length() > 0))
	    {
	    try {
	    System.out.println (s + "          \t-> \t" + d.OldtoNew (s));
		}
	    catch (DateException e)
		{
		System.out.println (s + e.getMessage());
		}
	    }
	// Schliet das File
	file.close ();
	}
    }


// Datums Exceptions Klasse
class DateException extends Exception {
    DateException (String s)
	{
	super (s);
	}
     }


// Hier werden die Daten verwaltet
class Datum
    {
    private Daten d = new Daten (0,0,0,null);
    final static String s[] = {"Jnner", "Feber", "Mrz", "April", "Mai", "Juni", "July", "August", "September", "Oktober", "November", "Dezember"};

    // Hier werden die Daten abgelegt
    private class Daten
	{
        int Tag = 0, Monat = 0, Jahr = 0;
	String trennzeichen = null;

	// Konstruktor: hier werden die Variablen initialisiert
	Daten (int t, int m, int j, String tr)
	    {
	    Tag = t;
	    Monat = m;
	    Jahr = j;
	    trennzeichen = tr;
	    }
	}
	

    // Konstruktor
    public Datum ()
	{
	}
    

    // Wandelt String in Datum um und gibt es im neuen Format aus    
    String OldtoNew (String s) throws DateException
	{
	String h = null;
	
	// Stellt das Format fest
	if ((d.trennzeichen = GetDateFormat (s)) != null)
	    {

	    // Initialisiert Stringteiler und definiert die Trennzeichen
	    StringTokenizer T = new StringTokenizer (s,d.trennzeichen);
	    if (T.countTokens () != 3)
		throw new DateException (":\tFalsches Datumsformat - Datensatz ignoriert");

	    try {
		// Teilt des Datum je nach Format in seine Bestandteile auf
		if (d.trennzeichen.equals ("."))
		    {
		    d.Tag = Integer.parseInt (T.nextToken ());
		    h = T.nextToken();
		    
		    // Wenn kein Trennzeichen zw. Monat und Jahr, "hndische" Trennung
		    if ((MagString.ContainsNumbers (h)) && (h.length() > 3))
			{
			d.Monat = GetMonthIndex (h.substring (0, MagString.GetFirstNumber (h) - 1));
			d.Jahr = Integer.parseInt (h.substring (MagString.GetFirstNumber (h), h.length ()));
			}
		    else
			{
			d.Monat = GetMonthIndex (h);
			d.Jahr = Integer.parseInt (T.nextToken ());
			}
		    }
		else
		    {
		    d.Jahr = Integer.parseInt (T.nextToken ());
		    d.Monat = Integer.parseInt (T.nextToken ());
		    d.Tag = Integer.parseInt (T.nextToken ());
		    }

		// berprft, ob das gelesene Datum gltig ist. Wenn nicht, wird es ignoriert & eine Fehlermeldung ausgegeben
	        CheckDate (d);
	        }
	    catch (Exception e) {
	        throw new DateException (e.getMessage());
	        }
	    }
	else throw new DateException (":\tFalsches Datumsformat - Datensatz ignoriert");
	return getNewDate ();
	}   
    
    // Bestimmt den Index eines Monat aus einem String (Dez. -> 12)
    int GetMonthIndex (String monat)
	{
	for (int m = 1; m <= 12; m++)
	    if (monat.indexOf (getMonthName(m).substring (0,2)) >= 0)
		return m;
	return -1;
	}
    
    
    // Liefert den Namen eines Monats zurck
    String getMonthName (int monat)
	{
	return s[monat-1];
	}
    
    
    // berprft, ob das Datum gltig ist.
    void CheckDate (Daten d) throws DateException
	{
        if ((d.Monat < 1) || (d.Monat > 12))
	    throw new DateException (":\tUngltiges Monat -  Datensatz ignoriert!");
	switch (d.Monat) {
	    case 4:
	    case 6:
	    case 9:
	    case 11:	if ((d.Tag < 1) || (d.Tag > 30))
			throw new DateException (":\tUngltiger Tag - Datensatz ignoriert!");
	    case 2:	if (((d.Jahr % 4) != 0) && (d.Tag > 28) || (d.Tag > 29))
			throw new DateException (":\tUngltiger Tag (Beachte Schaltjahre) - Datensatz ignoriert!");
	    default:	if ((d.Tag < 1) || (d.Tag > 31))
			throw new DateException (":\tUngltiger Tag - Datensatz ignoriert!");
	    }
	}
	
	
    // Bestimmt das Trennzeichen und bergibt es an das aufrufende Programm
    public String GetDateFormat (String s)
	{
	char h = ' ';
	
	// berprft, ob letztes Zeichen kein Trennzeichen
	h = s.charAt(s.length()-1);
	if ((h == '.') || (h == '-') || (h=='/'))
	    return null;
	
	// berprft das Format und bestimmt das Trennzeichen
	if ((s.indexOf ('/') > 0) && (s.indexOf (' ') < 0) && (s.indexOf ('-') < 0) && (s.indexOf ('.') < 0)) return "/";
	else if ((s.indexOf ('-') > 0) && (s.indexOf (' ') < 0) && (s.indexOf ('/') < 0) && (s.indexOf ('.') < 0)) return "-";
	else if ((s.indexOf ('.') > 0) && (s.indexOf ('/') < 0) && (s.indexOf ('-') < 0)) return ".";
	return null;
	}
    

    // Gibt Datum im neuen Format als String zurck
    public String getNewDate ()
	{
	String h;
	NumberFormat N = NumberFormat.getInstance ();

	// Deaktiviert Trennung bei Tausenderstellen	
	N.setGroupingUsed (false);

	// setzt Zahlenformat auf minimal 4 Stellen
	N.setMinimumIntegerDigits (4);
	h = N.format (d.Jahr);
	
	// setzt Zahlenformat auf minimal 2 Stellen
	N.setMinimumIntegerDigits (2);
	
	if (d.trennzeichen.equals ("."))
	    return h + "/" + N.format (d.Monat) + "/" + N.format (d.Tag);
	else 
	    return d.Tag + ". " + getMonthName (d.Monat) + " " + d.Jahr;
	}
    }
        